@echo off
title IMAGE HEALTH - Version 12.23.2015
color 17
set dism=%systemroot%\system32\dism.exe
%windir%\system32\reg.exe query "HKU\S-1-5-19" >nul 2>&1 || (
echo.
echo ===============================================================================
echo.                     ADMINISTRATOR PRIVILEGES NOT DETECTED
echo.
echo.        RIGHT CLICK ON THIS SCRIPT AND SELECT 'RUN AS AN ADMINISTRATOR'
echo ===============================================================================
echo. Press Any Key To Exit..
pause >nul
goto :eof
)
if exist "%windir%\logs\dism\dism.log" (
del /f /q "%windir%\logs\dism\dism.log" >nul 2>&1
)
:menu
set userinp=
cls
echo.
echo.   IMAGE HEALTH PROGRAM OPTIONS
echo ===============================================================================
echo.  Press 0 -  TO CREATE DETAILS REPORT and EXIT PROGRAM 
echo.  Press 1 -  Run Dism /Online /Cleanup-Image /ScanHealth
echo.  Press 2 -  Run Dism /Online /Cleanup-Image /RestoreHealth
echo.  Press 3 -  Run Dism /Online /Cleanup-Image /RestoreHealth /Source            
echo.  Press 4 -  Run Dism /Online /Cleanup-Image /AnalyzeComponentStore
echo.  Press 5 -  Run Dism /Online /Cleanup-Image /StartComponentCleanup
echo.  Press 6 -  Run Dism /Online /Cleanup-Image /StartComponentCleanup /ResetBase
echo.  Press 7 -  Run Dism /Online /Cleanup-Image /revertpendingactions
echo.  Press 8 -  Run SFC /Scannow
echo.  Press 9 -  Run Disk Cleanup Manager - Extended Mode
echo.  Press 10 - Run CheckDisk to Scan ^& Fix Disk Errors
echo.  Press 11 - Run ShowKeyPlus to retrieve Windows Product Key
echo.  Press 12 - Export 3rd Party System Drivers via Dism
echo.  Press 13 - Restore User Files from Windows.old to current User Folders
echo ===============================================================================
set /p userinp= ^> Enter Your Option: 
set userinp=%userinp:~0,3%
if %userinp%==0 goto :done
if %userinp%==1 goto :opt1
if %userinp%==2 goto :opt2
if %userinp%==3 goto :opt3
if %userinp%==4 goto :opt4
if %userinp%==5 goto :opt5
if %userinp%==6 goto :opt6
if %userinp%==7 goto :opt7
if %userinp%==8 goto :opt8
if %userinp%==9 goto :opt9
if %userinp%==10 goto :opt10
if %userinp%==11 goto :opt11
if %userinp%==12 goto :opt12
if %userinp%==13 goto :opt13
goto :eof
:opt1
cls
echo.
echo ===============================================================================
echo.  Dism is scanning the online image for health.
echo.  Dism will report whether the image is Healthy or Repairable
echo.  If Dism reports as repairable - Select Option 2
echo.  Please Wait.. This will take 5-10 minutes..
echo ===============================================================================
%Dism% /Online /Cleanup-Image /ScanHealth
pause
goto :menu
:opt2
cls
echo.
echo ===============================================================================
echo.  Dism uses Windows Update to provide the files required to fix corruption.
echo.  If Dism reports Source Files Could Not Be Found - Select Option 3
echo.  Please Wait.. This will take 10-15 minutes or more..
echo ===============================================================================
%Dism% /Online /Cleanup-Image /RestoreHealth
pause
goto :menu
:opt3
cls
for %%i in (D E F G H I J K L M N O P Q R S T U V W X Y Z) do if exist "%%i:\\sources\install.wim" set setupdrv=%%i
if defined setupdrv (
echo.
echo ===============================================================================
echo.  Found Source Install.wim on Drive %setupdrv%:
echo ===============================================================================
goto :restorewim
)
for %%i in (D E F G H I J K L M N O P Q R S T U V W X Y Z) do if exist "%%i:\\sources\install.esd" set setupdrv=%%i
if defined setupdrv (
echo.
echo ===============================================================================
echo.  Found Source Install.esd on Drive %setupdrv%:
echo ===============================================================================
goto :esdmenu
)
if not defined setupdrv (
echo.
echo ===============================================================================
echo.  No Installation Media Found!
echo.
echo.  Mount Media ISO or Insert DVD or USB flash drive and run this option again. 
echo ===============================================================================
pause
goto :menu
)
:restorewim
echo.
echo ===============================================================================
echo.  Dism is restoring the online image health using the source Install.wim
echo.  Please Wait.. This will take 10-15 minutes or more..
echo ===============================================================================
%Dism% /Online /Cleanup-Image /RestoreHealth /source:wim:%setupdrv%:\sources\install.wim:1 /limitaccess
pause
goto :menu
:esdmenu
set userinp=
echo.
echo ===============================================================================
echo.  Press 1 - If the Current Host OS is Windows 10
echo.  Press 2 - If the Current Host OS is NOT Windows 10
echo ===============================================================================
set /p userinp= ^> Enter Your Option: 
set userinp=%userinp:~0,3%
if %userinp%==1 goto :restoreesd
if %userinp%==2 goto :exportesd
goto :menu
:restoreesd
echo.
echo ===============================================================================
echo.  Dism is restoring the online image health using the source Install.esd
echo.  Please Wait.. This will take 10-15 minutes or more..
echo ===============================================================================
%Dism% /Online /Cleanup-Image /RestoreHealth /source:esd:%setupdrv%:\sources\install.esd:1 /limitaccess
pause
goto :menu
:exportesd
set wimlib=%~dp0bin\wimlib-imagex.exe
%windir%\system32\reg.exe query "hklm\software\microsoft\Windows NT\currentversion" /v buildlabex | find /i "amd64" 1>nul && set wimlib=%~dp0bin\bin64\wimlib-imagex.exe
if not exist "%~dp0bin\wimlib-imagex.exe" (echo.&echo ERROR: Required Bin Files Not Found.&PAUSE&GOTO :EOF)
if not exist "%~dp0Temp\install.wim" (
echo.
echo ===============================================================================
echo.  Exporting the Sources\Install.esd into a Source\Install.wim
echo.  Please Wait.. This will take 5-10 minutes..
echo ===============================================================================
md "%~dp0Source"
"%wimlib%" export "%setupdrv%:\sources\install.esd" 1 "%~dp0Source\install.wim" --compress=maximum
)
echo.
echo ===============================================================================
echo.  Dism is restoring the online image health using the source media.
echo.  Please Wait.. This will take 10-15 minutes or more..
echo ===============================================================================
%Dism% /Online /Cleanup-Image /RestoreHealth /Source:wim:"%~dp0Source\install.wim":1 /LimitAccess
pause
goto :menu
:opt4
cls
echo.
echo ===============================================================================
echo.  Dism is Analyzing the Component Store.
echo.  If Dism reports Component Store Cleanup Recommended - Select Option 5 or 6 
echo.  Please Wait.. This will take 5-10 minutes..
echo ===============================================================================
%Dism% /Online /Cleanup-Image /AnalyzeComponentStore
pause
goto :menu
:opt5
cls
echo.
echo ===============================================================================
echo.  Dism is Cleaning Up the Component Store.
echo.  Please Wait.. This will take 10-15 minutes..
echo ===============================================================================
%Dism% /Online /Cleanup-Image /StartComponentCleanup
pause
goto :menu
:opt6
cls
echo.
echo ===============================================================================
echo.  Dism is Resetting the Component Store.
echo.  Please Wait.. This will take 10-15 minutes or more..
echo ===============================================================================
%Dism% /Online /Cleanup-Image /StartComponentCleanup /ResetBase
pause
goto :menu
:opt7
cls
echo.
echo ===============================================================================
echo.  Dism is Reverting any Pending Dism Actions.
echo.  Please Wait.. This will take several minutes..
echo ===============================================================================
%Dism% /online /Cleanup-Image /revertpendingactions
pause
goto :menu
:opt8
cls
echo.
echo ===============================================================================
echo.  System File Checker is scanning the online image for corruption. 
echo.  Please Wait.. This will take 10-15 minutes or more..
echo ===============================================================================
if exist "%windir%\logs\cbs\cbs.log" (
del /f /q "%windir%\logs\cbs\cbs.log" >nul 2>&1
)
sfc.exe /scannow
findstr /c:"[SR]" %windir%\logs\cbs\cbs.log >"%userprofile%\desktop\SFC Details.txt"
echo ===============================================================================
echo.  A SFC Details Report was Created on your Desktop
echo ===============================================================================
pause
goto :menu
:opt9
cls
echo.
echo ===============================================================================
echo.  Running Extended Disk Cleanup Manager
echo.  Check your choice of the Cleanup options and hit ok
echo.  Please Wait.. This will take several minutes..
echo ===============================================================================
%SystemRoot%\System32\Cmd.exe /c Cleanmgr /sageset:65535 
%SystemRoot%\System32\Cmd.exe /c Cleanmgr /sagerun:65535
pause
goto :menu
:opt10
cls
echo.
echo ===============================================================================
echo.  Check Disk can not repair disk volumes that are in use..
echo.  If the disk volume is in use, Check Disk will prompt you to schedule..  
echo.  What Disk Volume would you like to scan for errors?
echo ===============================================================================
set /p volume= ^> Enter Drive Letter:
chkdsk %volume%: /F
goto :menu
:opt11
start "%~dp0bin\showkeyplus.exe"
goto :menu
:opt12
echo.
echo ===============================================================================
echo.  Press 1 - TO EXPORT DRIVERS FROM THE CURRENT WINDOWS OS 
echo.  Press 2 - TO EXPORT DRIVERS FROM AN OFF-LINE WINDOWS OS
echo ===============================================================================
set /p userinp= ^> Enter Your Option: 
set userinp=%userinp:~0,3%
if %userinp%==1 goto :current
if %userinp%==2 goto :offline
:current
echo.
echo ===============================================================================
echo.  EXPORTING CURRENT WINDOWS SYSTEM DRIVERS
echo ===============================================================================
md "%~dp0Drivers"
%Dism% /online /Export-Driver /Destination:"%~dp0drivers"
pause
goto :menu
:offline
echo.
echo ===============================================================================
echo.  PLEASE ENTER THE DRIVE LETTER FOR THE OFF-LINE WINDOWS OS
echo ===============================================================================
set /p drvlttr= ^> Enter Drive Letter:
echo.
echo ===============================================================================
echo.  EXPORTING THE OFF-LINE WINDOWS SYSTEM DRIVERS
echo ===============================================================================
md "%~dp0Drivers"
%dism% /Image:%drvlttr%:\ /Export-Driver /Destination:"%~dp0drivers"
pause
goto :menu
:opt13
call "%~dp0bin\windowsmigration.diagcab"
goto :menu
:done
cls
echo.
echo.   IMAGE_HEALTH.CMD
echo.   WRITTEN BY KYHI
echo.   DECEMBER 23,2015
echo.
echo ===============================================================================
echo.  A Dism Details Report will be created on your Desktop
echo ===============================================================================
timeout /t 4 >nul
copy %windir%\logs\dism\dism.log "%userprofile%\desktop\Dism Details.txt"
if exist "%~dp0Source" rmdir /s /q "%~dp0Source"
goto :eof